#include "Joyce.h"
#include "Joycevga.h"
#include "Joycemou.h"
#include "keyboard.h"

void txt2fcb(word addr, char *s);

word jdos_wildex(Z80 *R)
	{
	char pathname[4 * _POSIX_PATH_MAX];
	int m = 0, n = 0;
	char c;
	glob_t results;

        do {
                c = RdZ80(R->DE.W + m); /* Extract pathname */
                pathname[m] = c;
                ++m;
        } while (c);

	/* Case-insensitivity (from v1.31) removed, now that utilities have
          been rewritten for case-sensitivity */

	if (glob(pathname, GLOB_MARK, NULL, &results)) return 0;
	
        m = R->BC.B.h;

	for (n = 0; n < results.gl_pathc; n++)
        {	
		char *s = results.gl_pathv[n];

		/* Skip directories */
		if (s[0] && s[strlen(s) - 1] == '/') continue;
		if (m == 0) break;  
		--m;
        }
	/* Was a match found? */
	if (n >= results.gl_pathc) { globfree(&results); return 0; }

	/* Work out what we got. */

        txt2fcb(R->HL.W, results.gl_pathv[n]);
        m = (-1);
        do {
                ++m;
                WrZ80(R->HL.W + m + 11, results.gl_pathv[n][m]);
        } while (results.gl_pathv[n][m]);

	globfree(&results);

	return 1;
	}



